package cn.iocoder.yudao.module.member.dal.mysql.userpreference;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.member.controller.admin.userpreference.vo.UserPreferencePageReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.userpreference.UserPreferenceDO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 用户偏好 Mapper
 *
 * @author 开发账号
 */
@Mapper
public interface UserPreferenceMapper extends BaseMapperX<UserPreferenceDO> {

    default PageResult<UserPreferenceDO> selectPage(UserPreferencePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<UserPreferenceDO>()
                .eqIfPresent(UserPreferenceDO::getUserId, reqVO.getUserId())
                .eqIfPresent(UserPreferenceDO::getSpicy, reqVO.getSpicy())
                .eqIfPresent(UserPreferenceDO::getTaste, reqVO.getTaste())
                .eqIfPresent(UserPreferenceDO::getHealth, reqVO.getHealth())
                .eqIfPresent(UserPreferenceDO::getFoodType, reqVO.getFoodType())
                .eqIfPresent(UserPreferenceDO::getAllergy, reqVO.getAllergy())
                .eqIfPresent(UserPreferenceDO::getDemand, reqVO.getDemand())
                .eqIfPresent(UserPreferenceDO::getRestriction, reqVO.getRestrict())
                .eqIfPresent(UserPreferenceDO::getCustom, reqVO.getCustom())
                .betweenIfPresent(UserPreferenceDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(UserPreferenceDO::getId));
    }

    Integer selectCountByType(String Type);

}